package de.bablokb.epm;

import org.eclipse.jface.action.GroupMarker;
import org.eclipse.jface.action.ICoolBarManager;
import org.eclipse.jface.action.IMenuManager;
import org.eclipse.jface.action.IToolBarManager;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.action.ToolBarContributionItem;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.ui.IWorkbenchActionConstants;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.actions.ActionFactory;
import org.eclipse.ui.actions.ActionFactory.IWorkbenchAction;
import org.eclipse.ui.application.ActionBarAdvisor;
import org.eclipse.ui.application.IActionBarConfigurer;

public class ApplicationActionBarAdvisor extends ActionBarAdvisor {

    private IWorkbenchAction iExitAction;
	private IWorkbenchAction iAboutAction;
	private IWorkbenchAction iNewWindowAction;
	private IWorkbenchAction iHelpAction;
	// private OpenArchiveAction iOpenArchiveAction;

    public ApplicationActionBarAdvisor(IActionBarConfigurer configurer) {
      super(configurer);
    }

    protected void makeActions(IWorkbenchWindow window) {
      iExitAction = ActionFactory.QUIT.create(window);
      register(iExitAction);
        
      iAboutAction = ActionFactory.ABOUT.create(window);
      register(iAboutAction);
        
      iNewWindowAction = ActionFactory.OPEN_NEW_WINDOW.create(window);
      register(iNewWindowAction);
        
      // iOpenArchiveAction = new OpenArchiveAction(window, "Open Another Archive View", ArchiveView.ID);
      // register(iOpenArchiveAction);

	  iHelpAction = ActionFactory.HELP_CONTENTS.create(window);
	  register(iHelpAction);
    }

    protected void fillMenuBar(IMenuManager menuBar) {
      menuBar.add(createArchiveMenu());
      menuBar.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
      menuBar.add(createHelpMenu());
    }
    
   private MenuManager createArchiveMenu() {
      MenuManager archiveMenu = new MenuManager("&Archive", IWorkbenchActionConstants.M_FILE);
      archiveMenu.add(iNewWindowAction);
      archiveMenu.add(new Separator());
      // archiveMenu.add(iOpenArchiveAction);
      archiveMenu.add(new Separator());
      archiveMenu.add(iExitAction);
      return archiveMenu;
    }
    
	private MenuManager createHelpMenu() {
		MenuManager menu = new MenuManager("&Help", IWorkbenchActionConstants.M_HELP);
		menu.add(iHelpAction);
		menu.add(new GroupMarker(IWorkbenchActionConstants.HELP_START));
		menu.add(new GroupMarker(IWorkbenchActionConstants.HELP_END));
		menu.add(new GroupMarker(IWorkbenchActionConstants.MB_ADDITIONS));
		menu.add(new Separator());
		// About should always be at the bottom
		menu.add(iAboutAction);
		return menu;
	}

    protected void fillCoolBar(ICoolBarManager coolBar) {
      IToolBarManager toolbar = new ToolBarManager(SWT.FLAT | SWT.RIGHT);
      coolBar.add(new ToolBarContributionItem(toolbar, "main"));   
      toolbar.add(iExitAction);
      // toolbar.add(iOpenArchiveAction);
    }    
}
