/**
 * 
 */
package de.bablokb.epm.views;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StringWriter;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.ISelectionListener;
import org.eclipse.ui.IViewSite;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.ViewPart;

/**
 * @author bablokb
 * 
 */
public class CmdResultView extends ViewPart implements ISelectionListener {

	private String iCmdName = null;
    private String iFilename = null;
	private Text iTextfield = null;

	/**
	 * 
	 */
	public CmdResultView(String cmdName) {
		super();
		iCmdName = cmdName;
	}

	
	public void init(IViewSite site) throws PartInitException {
		// TODO Auto-generated method stub
		super.init(site);

	}


	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.part.WorkbenchPart#createPartControl(org.eclipse.swt.widgets.Composite)
	 */
	public void createPartControl(Composite parent) {
		iTextfield = new Text(parent, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
		iTextfield.setEditable(false);
		iTextfield.setTabs(8);
		getViewSite().getPage().addSelectionListener(this);
		selectionChanged(this,getViewSite().getPage().getSelection());
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.ui.part.WorkbenchPart#setFocus()
	 */
	public void setFocus() {
		iTextfield.setFocus();
	}

public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		// if (selection == null) {
		// iCanvas.setImageData(null);
		// return;
		// }
		if (selection instanceof IStructuredSelection) {
			Object obj = ((IStructuredSelection) selection).getFirstElement();
			if (obj == null) {
				iTextfield.setText("");
			}
			if (obj instanceof String) {
				String fileName = (String) obj;
				if (fileName.equals(iFilename)) {
					return;
				}
				iFilename = fileName;
				showBusy(true);
				iTextfield.setText(runCmd(fileName));
				showBusy(false);
			}
		}
		
	}	private String runCmd(String filename) {
		try {
			Process pr = Runtime.getRuntime().exec(iCmdName + " " + filename);
			InputStream in = pr.getInputStream();
			InputStreamReader reader = new InputStreamReader(in);
			BufferedReader bufreader = new BufferedReader(reader);
			String line;
			StringWriter strw = new StringWriter(4096);
			PrintWriter prw = new PrintWriter(strw);
			while ((line=bufreader.readLine()) != null) {
				prw.println(line);
			}
			prw.close();
			return strw.toString();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

}
