/**
 * 
 */
package de.bablokb.epm.views;


import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.INullSelectionListener;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.part.ViewPart;

import de.bablokb.epm.utils.ImageCanvas;

/**
 * @author bablokb
 * 
 */
public class ImageView extends ViewPart implements INullSelectionListener {
	public final static String VIEW_ID="ImageView";

	private ImageCanvas iCanvas;
	private String iFilename;
	
	/**
	 * The constructor.
	 */
	public ImageView() {
	}
	
	/**
	 * Create the GUI.
	 * @param parent The Composite handle of parent
	 */
	public void createPartControl(Composite parent) {
		iCanvas=new ImageCanvas(parent);
		getViewSite().getPage().addSelectionListener(this);
	}

	public ImageCanvas getCanvas() {
		return iCanvas;
	}
	/**
	 * Called when we must grab focus.
	 * @see org.eclipse.ui.part.ViewPart#setFocus
	 */
	public void setFocus() {
		iCanvas.setFocus();
	}

	/**
	 * Called when the View is to be disposed
	 */
	public void dispose() {
		iCanvas.dispose();
		super.dispose();
	}

	public void selectionChanged(IWorkbenchPart part, ISelection selection) {
		if (selection instanceof IStructuredSelection) {
			Object obj = ((IStructuredSelection) selection).getFirstElement();
			if (obj == null) {
				iCanvas.setImageData(null);
			}
			if (obj instanceof String) {
				String fileName = (String) obj;
				if (fileName.equals(iFilename)) {
					return;
				}
				iFilename = fileName;
				showBusy(true);
				iCanvas.loadImage(fileName);
    			iCanvas.fitCanvas();
    			iCanvas.syncScrollBars();
				showBusy(false);
			}
		}
	}
}
